# Text Editor
Version `1.6`

![](README/readme_preview.png)

***Warning: Use at your own risk. Backup your files before testing.***

# Features
- Tabs with scroll
- File filtering
- Highlighting for common file formats (`md` `json`...)
- Tag filtering system
- File Management:
	- Creation
	- Renaming
	- Recycling
- Auto save/load settings
- Many little *Ease of life* functions:
	- Folder open/close
	- Comment toggling for:
		- `.md`: `<!-- -->`
		- `.json`: `/* */`
		- `.ini`: `; `
		- `.cfg`: `; `
		- `.yaml`: `# `

# Controls
- `ctrl + W` Close file
- `ctrl + N` New file
- `ctrl + shift + W` Open last closed file 
- `ctrl + tab` Select next open file
- `ctrl + shift + tab` Select last open file
- `ctrl + mouse wheel` Adjust font size
- `ctrl + shift + mouse wheel` Adjust ui font size
- `ctrl + up` `ctrl + down` Move selected lines
- `ctrl + /` Toggle line comments
- `ctrl + M` Toggle file meta info
- `ctrl + F` Search for text in all files

## Symbol View
- `ctrl + click` Select entire block + children.
- `ctrl + shift + click` Select block without children.

# Symbols and Tags
To make it easier to find stuff there is a *Symbol* viewer.

- `Markdown` uses headings `# Heading`
- `JSON` uses Dictionaries `"object": {`
- `YAML` uses Dictionaries `object: `
- `ini` `cfg` use headings `[heading]`

Symbols can have tags. Tags are added with comments.

- `Markdown` uses `<!-- #tag1 #tag2 -->`
- `JSON` uses `"#": "#tag1 #tag2"`
- `YAML` uses `# #tag1 #tag2` or `"#": "#tag1 #tag2"`
- `ini` `cfg` uses `; #tag1 #tag2`

Symbols are per file, tags are shared across files.

When a file is opened with tags, they show up in bottom right *Tag Container*.

Click them to toggle on and off.\
This will then highlight *Files* and *Symbols* that have that tag.

# Todo
- [x] `1.1` Preserve folders open/close state.
- [x] `1.3` Search all files.
- [ ] Search file.
- [ ] Find and replace.
- [ ] Improve meta data based on format.
- [x] `1.2` Recycle folders.
- [x] `1.2` Unrecylce. (Toggle `view/directories/.trash` and press green arrow.
- [ ] JSON formatting.
- [ ] JSON error testing.